package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.AimTemplateAr;
import com.izouma.awesomeadmin.service.AimTemplateArService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/aimTemplateAr")
public class AimTemplateArController {

    @Autowired
    private AimTemplateArService aimTemplateArService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(AimTemplateAr record) {
        List<AimTemplateAr> pp = aimTemplateArService.getAimTemplateArList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getAimTemplateAr", method = RequestMethod.GET)
    @ResponseBody
    public Result getAimTemplateAr(@RequestParam(required = false, value = "id") String id) {
        AimTemplateAr data = aimTemplateArService.getAimTemplateArById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(AimTemplateAr record) {
        AimTemplateAr data = aimTemplateArService.getAimTemplateAr(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, AimTemplateAr record) {
        Map<String, Object> result = new HashMap<>();

        List<AimTemplateAr> pp =aimTemplateArService.getAimTemplateArByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(AimTemplateAr record) {
        boolean num = aimTemplateArService.createAimTemplateAr(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateAimTemplateAr(AimTemplateAr record) {
        boolean num = aimTemplateArService.updateAimTemplateAr(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteAimTemplateAr(AimTemplateAr record) {

        boolean num = aimTemplateArService.deleteAimTemplateAr(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, AimTemplateAr record) throws Exception {

    List<AimTemplateAr> aimTemplateArs = aimTemplateArService.getAimTemplateArList(record);


        String sheetName = "aim_template_ar";
        String titleName = "点标模板AR数据表";
        String fileName = "点标模板AR表";
        int columnNumber = 13;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "ar内容名称" ,   "ar类型" ,   "激活方式" ,   "备注" ,   "模板" ,   "模板点标" ,   "权限"  };
        String[][] dataList = new String[aimTemplateArs.size()][13];

        for (int i = 0; i < aimTemplateArs.size(); i++) {

                        dataList[i][0] = String.valueOf(aimTemplateArs.get(i).getId());
                        dataList[i][1] = String.valueOf(aimTemplateArs.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(aimTemplateArs.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(aimTemplateArs.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(aimTemplateArs.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(aimTemplateArs.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(aimTemplateArs.get(i).getArName());
                        dataList[i][7] = String.valueOf(aimTemplateArs.get(i).getArType());
                        dataList[i][8] = String.valueOf(aimTemplateArs.get(i).getActivationMode());
                        dataList[i][9] = String.valueOf(aimTemplateArs.get(i).getRemark());
                        dataList[i][10] = String.valueOf(aimTemplateArs.get(i).getTemplateId());
                        dataList[i][11] = String.valueOf(aimTemplateArs.get(i).getTemplateAimId());
                        dataList[i][12] = String.valueOf(aimTemplateArs.get(i).getPower());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

